;;;; -*- Mode:Common-Lisp; Package:COMMON-LISP-USER; Base:10 -*-
;;;; *-* File: /usr/users/eksl/systems/clasp/dev/clasp-interface-system.lisp *-*
;;;; *-* Last-Edit: Wednesday, May 29, 1996  15:36:27; Edited-By: Westy *-*
;;;; *-* Machine: Lindy (Alpha) *-*
;;;; *-* Software: Harlequin Common Lisp 3.2 *-*

;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;; Copyright (c) 1990 - 1994 University of Massachusetts
;;; Department of Computer and Information Science
;;; Experimental Knowledge Systems Laboratory
;;; Professor Paul Cohen, Director.
;;; All rights reserved.
;;; 
;;; Permission to use, copy, modify and distribute this software and its
;;; documentation is hereby granted without fee for non-commercial uses only 
;;; (not for resale), provided that the above copyright notice of EKSL, this 
;;; paragraph and the one following appear in all copies and in supporting 
;;; documentation.
;;; EKSL makes no representation about the suitability of this software for any
;;; purposes.  It is provided "AS IS", without express or implied warranties
;;; including (but not limited to) all implied warranties of merchantability
;;; and fitness for a particular purpose, and notwithstanding any other
;;; provision contained herein.  In no event shall EKSL be liable for any
;;; special, indirect or consequential damages whatsoever resulting from loss
;;; of use, data or profits, whether in an action of contract, negligence or
;;; other tortuous action, arising out of or in connection with the use or
;;; performance of this software, even if EKSL is
;;; advised of the possiblity of such damages.
;;; 
;;; For more information write to clasp-support@cs.umass.edu
;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

(in-package :common-lisp-user)

;;; --*--
;;; ***************************************************************************

(define-eksl-system CLASP-INTERFACE
   #+CLIM
   (#+clim-1
    "clim-1-compatibility" "dwim-patches"
    "scigraph-patches" "packages" "errors" 
    #+OLD "icon-defs" #+OLD "icon" #+OLD "define-icons" 
    "class-defs" "utilities"
    "frame" "inferior-frame" "result-methods" "history"
    "defclaspcom" "listener" "lisp-presentations" "display"
    "numeric-result-classes" "significance-classes"
    "confidence-int-classes"
    "anova-classes"
    "regression-classes" "file-commands" "graph-commands"
    "stat-commands" "test-commands" "data-manipulation-commands"
    "transform-commands" "sampling-commands" "boots"
    ;; temporary. maybe
    "new-anova-interface")
   #+(and MCL (not CLIM))
   ("packages"
    (("packages"
      "utils"
      "applescript"
      "applescript-editor"
      "drag-and-drop")
      :base-dir "clasp:interface;contrib;"
      :bin-identifiers (:platform :vendor :gui)
      )
     
    "parameters"
    "tables-support"
    "result-labels"
    "openable-items"
    "pop-up-menu-patch"
    "drag-and-drop-support"
    "utilities-from-clim"
    "clasp-command"
    "preferences-window"
    "extra-items"
    "dataset-view"
    "history-view"
    "status-view"
    "clasp-window"
    "menu-functions"
    "menu-items"
    "pict-di"
    "array-dialog-item"
    "function-dialog-utils"
    "tables"
    "clasp-dock"
    "data-view"
    "misc-describe"
    "manipulate"
    "transforms"
    "generic-dialogs"
    "graph-interface"
    "graph-edit"
    "test-dialogs"
    "distrib-interface"
    "caddy-class"
    "interface-support-fns"
    "ribbon-window"
    "notebook-class"
    "event-logging"
    "logging"
    "cut-n-paste"
    "menus"
    "about-box"
    "toplevel"
    "help"
    ;; temporary. maybe.
    "temp-contrasts"
    #+CCL-3
    "clasp-application"
    "last-file"
    )
   :base-dir "CLASP:INTERFACE;"
   :bin-identifiers (:platform :vendor :gui))

;;;----------------------------------------------------------------------------
;;; EOF
