;;; -*- Mode:Common-Lisp; Package:COMMON-LISP-USER; Base:10 -*-

;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;; Copyright (c) 1990 - 1994 University of Massachusetts
;;; Department of Computer and Information Science
;;; Experimental Knowledge Systems Laboratory
;;; Professor Paul Cohen, Director.
;;; All rights reserved.
;;; 
;;; Permission to use, copy, modify and distribute this software and its
;;; documentation is hereby granted without fee for non-commercial uses only 
;;; (not for resale), provided that the above copyright notice of EKSL, this 
;;; paragraph and the one following appear in all copies and in supporting 
;;; documentation.
;;; EKSL makes no representation about the suitability of this software for any
;;; purposes.  It is provided "AS IS", without express or implied warranties
;;; including (but not limited to) all implied warranties of merchantability
;;; and fitness for a particular purpose, and notwithstanding any other
;;; provision contained herein.  In no event shall EKSL be liable for any
;;; special, indirect or consequential damages whatsoever resulting from loss
;;; of use, data or profits, whether in an action of contract, negligence or
;;; other tortuous action, arising out of or in connection with the use or
;;; performance of this software, even if EKSL is
;;; advised of the possiblity of such damages.
;;; 
;;; For more information write to clasp-support@cs.umass.edu
;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

(in-package :USER)

;;; --*--
;;; ***************************************************************************

(define-eksl-system CLASP
    (#+allegro
    "ansi-patches"
    "packages"
    #+OLD-VARS "rtm-patches"
    "parameters"
    "utilities"
    "super-intrinsic-mixins"
    "intrinsic-mixins"
    "defs"
    "variable-value"
    "vector-fns"
    "errors"
    "dataset-fns"
    "define-statistical-fun"
    "translation-fns"
    "manipulation-fns"
    "density-fns"
    "matrix-fns"
    "matrices"
    "find-critical"
    "svd"
    "statistics"
    "sampling-fns"
    "io-fns"
    "shortcuts"
    "reader-macro"
    "bootstrap"
    "standardize"
    "exports"
    ;; these probably belong somewhere else
    "tmp-contrast"
    "3d-tables"
    )
   :base-dir "CLASP:SOURCE;"
   :bin-identifiers (:platform :vendor))
   





