;;;; -*- Package: COMMON-LISP-USER; Mode:Common-Lisp; Base:10 -*-
;;;; *-* File: /usr/users/eksl/systems/clasp/dev/clasp-translations.lisp *-*
;;;; *-* Last-Edit: Wednesday, May 29, 1996  15:31:22; Edited-By: Westy *-*
;;;; *-* Machine: Lindy (Alpha) *-*
;;;; *-* Software: Harlequin Common Lisp 3.2 *-*

;;; Copyright (c) 1990 - 1994 University of Massachusetts
;;; Department of Computer Science
;;; Experimental Knowledge Systems Laboratory
;;; Professor Paul Cohen, Director.
;;; All rights reserved.

;;; Permission to use, copy, modify and distribute this software and its
;;; documentation is hereby granted without fee, provided that the above
;;; copyright notice of EKSL, this paragraph and the one following appear
;;; in all copies and in supporting documentation.
;;; EKSL makes no representation about the suitability of this software for any
;;; purposes.  It is provided "AS IS", without express or implied warranties
;;; including (but not limited to) all implied warranties of merchantability
;;; and fitness for a particular purpose, and notwithstanding any other
;;; provision contained herein.  In no event shall EKSL be liable for any
;;; special, indirect or consequential damages whatsoever resulting from loss
;;; of use, data or profits, whether in an action of contract, negligence or
;;; other tortuous action, arising out of or in connection with the use or
;;; performance of this software, even if EKSL is advised of the possiblity of
;;; such damages.

;;; For more information write to clasp-support@cs.umass.edu

(in-package :COMMON-LISP-USER)

(setf (eksl-logical-pathname-translations "CLASP")
      `(("CLASP;**;*.*.*"
	 ,(relative-namestring "CODE" :wild-inferiors))
	("CLASP;*.*.*"
	 ,(relative-namestring "CODE"))
	("SOURCE;**;*.*.*"
	 ,(relative-namestring "CODE" :wild-inferiors))
	("SOURCE;*.*.*"
	 ,(relative-namestring "CODE"))
	("BINARY;**;*.*.*"
	 ,(relative-namestring "CODE" (bin-directory-name)
					 :wild-inferiors))
	("BINARY;*.*.*"
	 ,(relative-namestring "CODE" (bin-directory-name)))
	;; In this case, the interface files are in a subdirectory
	("INTERFACE;**;*.*.*"
	 ,(relative-namestring #+(or (not MCL) CLIM) "INTERFACE" #+(and MCL (not CLIM)) "INTERFACE-MCL" :wild-inferiors))
	("INTERFACE;*.*.*"
	 ,(relative-namestring #+(or (not MCL) CLIM) "INTERFACE" #+(and MCL (not CLIM)) "INTERFACE-MCL"))
	("INTERFACEBINARY;**;*.*.*"
	 ,(relative-namestring #+(or (not MCL) CLIM) "INTERFACE" #+(and MCL (not CLIM)) "INTERFACE-MCL" (bin-directory-name)
					 :wild-inferiors))
	("INTERFACEBINARY;*.*.*"
	 ,(relative-namestring #-MCL "INTERFACE" #+(and MCL (not CLIM)) "INTERFACE-MCL" (bin-directory-name)))
        
	;; Location of component systems, relative to this one.
	#-new-scigraph
	("SCIGRAPH;*.*.*"
	 ,(relative-namestring :back :back "SCIGRAPH"))
	#-new-scigraph
	("SCIGRAPH;**;*.*.*"
	 ,(relative-namestring :back :back "SCIGRAPH" :wild-inferiors))
	#-new-scigraph
	("DWIM;*.*.*"
	 ,(relative-namestring :back :back "DWIM"))
	#-new-scigraph
	("DWIM;**;*.*.*"
	 ,(relative-namestring :back :back "DWIM" :wild-inferiors))
        #+(and MCL (not CLIM))
        ("PLOTTER;*.*.*"
	 ,(relative-namestring :back :back "PLOTTER" "RELEASE"))
       #+(and MCL (not CLIM))
        ("PLOTTER;**;*.*.*"
	 ,(relative-namestring :back :back "PLOTTER" "RELEASE" :wild-inferiors))
	("DATA;**;*.*.*"
	 ,(relative-namestring :back "DATA" :wild-inferiors))
	("DATA;*.*.*"
	 ,(relative-namestring :back "DATA"))

        ("HTDOCS;**;*.*.*"
	 ,(relative-namestring :back "HTDOCS" :wild-inferiors))
	("HTDOCS;*.*.*"
	 ,(relative-namestring :back "HTDOCS"))

	("FBD;*.*.*"
	 ,(relative-namestring :back :back "PATH-ANALYSIS" "FBD-RELEASED"))
        ("FBD;**;*.*.*"
	 ,(relative-namestring :back :back "PATH-ANALYSIS" "FBD-RELEASED" :wild-inferiors))
	("MSDD;**;*.*.*"
	 ,(relative-namestring :back :back "MSDD" "DEVELOPMENT"))
	("MSDD;**;*.*.*"
	 ,(relative-namestring :back :back "MSDD" "DEVELOPMENT" :wild-inferiors))
	("IMSDD;**;*.*.*"
	 ,(relative-namestring :back :back "IMSDD" "DEVELOPMENT"))
	("IMSDD;**;*.*.*"
	 ,(relative-namestring :back :back "IMSDD" "DEVELOPMENT" :wild-inferiors))
	("CLASP-LAYERS;**;*.*.*"
	 ,(relative-namestring :back :back "CLASP-LAYERS" "DEVELOPMENT"))
	("CLASP-LAYERS;**;*.*.*"
	 ,(relative-namestring :back :back "CLASP-LAYERS" "DEVELOPMENT" :wild-inferiors))
	("EKSL-UTILS;**;*.*.*"
	 ,(relative-namestring :back :back "UTILS" "RELEASE"))
	("EKSL-UTILS;**;*.*.*"
	 ,(relative-namestring :back :back "UTILS" "RELEASE" :wild-inferiors))
	))
