;;;; -*- Mode:Common-Lisp; Package:COMMON-LISP-USER; Fonts:(MEDFNT); Base:10 -*-
;;;; *-* File: /usr/users/eksl/systems/clasp/clasp/dev/packages.lisp *-*
;;;; *-* Last-edit: Friday, November 12, 1993  13:10:50; Edited-By: StAmant *-* 
;;;; *-* Machine: Lester (Explorer II, Microcode 489) *-*
;;;; *-* Software: TI Common Lisp System 6.49 *-*
;;;; *-* Lisp: TI Common Lisp System 6.49  *-*

;;;; **************************************************************************
;;;; **************************************************************************
;;;; *                                                                        *
;;;; *                           Package Definitions                          *
;;;; *                                                                        *
;;;; **************************************************************************
;;;; **************************************************************************
;;;
;;; Written by: David L. Westbrook
;;;             Experimental Knowledge Systems Laboratory
;;;             Paul R. Cohen, Principal Investigator
;;;             David L. Westbrook, Systems Manager
;;;             David M. Hart, Laboratory Manager
;;;             Department of Computer Science
;;;             University of Massachusetts
;;;             Amherst, Massachusetts 01003.
;;;
;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;;
;;;  01-19-93 File Created.  (Westy)
;;;
;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;; --*--

(in-package :USER)

;;; --*--
;;; ***************************************************************************
 
(defpackage MATRICES)

#+(or CLIM-ANSI-CONDITIONS Allegro)
(pushnew :ANSI-CONDITIONS *features*)

(defpackage CLASP
  (:use #+(or allegro Explorer lcl4.0) CLOS 
	#+Explorer CL
	#+OLD-VARS RTM
	#+(or (not lucid) (and lucid ansi-packages))
	COMMON-LISP
	#+(and lucid (not ansi-packages))
	LISP
	MATRICES
        EKSL-UTILITIES)
  ;; CLASP's `named-object-mixin' is not compatible with the one in utils.
  (:shadow name name-string named-object-mixin remember-instances
   object-with-properties persistent-instances find-direct-instances
   find-instances find-instance-by-name kill reset
   kill-all-instances kill-all-remembered-instances get-value
   remember-original-values-mixin restore-original-values
   ;; group is defined in utils - probably should rename clasp's group
   group)
  ;; Two symbols that should not be in Lispworks CL package.
  #+Lispworks
  (:shadowing-import-from EKSL-UTILITIES FIXNUMP WITHOUT-INTERRUPTS)
  ;; The following shouldn't be necessary, but some people put
  ;; symbols in the lisp package.  We've actually had conflicts
  ;; with the 'variable symbol.  Anderson 11/12/93
  #-ALLEGRO
  (:shadow variable)
  #+(or LCL4.0 LCL4.1)
  (:import-from lucid-common-lisp define-condition handler-case
		type-error simple-error)
  #+(or LCL4.0 LCL4.1)
  (:import-from clos class-finalized-p class-precedence-list
		     class-direct-superclasses class-direct-subclasses)
  #+(or LCL4.0 LCL4.1)
  (:import-from lucid load-time-value)
  #+lucid
  (:import-from lucid destructuring-bind print-unreadable-object row-major-aref)
  #+MCL
  (:import-from ccl class-prototype class-direct-superclasses
		class-direct-subclasses class-precedence-list)
  #+Allegro
  (:import-from clos class-prototype class-direct-superclasses 
		class-direct-subclasses class-precedence-list
		class-finalized-p)
  #+LISPWORKS
  (:import-from clos class-prototype class-direct-superclasses class-direct-subclasses
                class-precedence-list class-finalized-p validate-superclass)
  ;; The TI doesn't have :import-from, so we use qualified names.  This will be okay on
  ;; non-Explorers because read-time conditionals bind *read-suppress*  SDA 5/13/93
  #+EXPLORER
  (:import cl:define-condition ticl:function-name ticl:push-end))

;;; ***************************************************************************
;;; EOF



