;;;; -*- Mode:Common-Lisp; Package:CLASP; Base:10 -*-
;;;; *-* File: /usr/users/eksl/systems/clasp/clasp/development/reader-macro.lisp *-*
;;;; *-* Last-edit: Monday, March 8, 1993  12:42:52; Edited-By: carlson *-* 
;;;; *-* Machine: Lester (Explorer II, Microcode 489) *-*
;;;; *-* Software: TI Common Lisp System 6.49 *-*
;;;; *-* Lisp: TI Common Lisp System 6.49  *-*

;;;; **************************************************************************
;;;; **************************************************************************
;;;; *                                                                        *
;;;; *                           Data Set Functions                           *
;;;; *                                                                        *
;;;; **************************************************************************
;;;; **************************************************************************
;;;
;;; Copyright (c) 1990 - 1994 University of Massachusetts
;;; Department of Computer Science
;;; Experimental Knowledge Systems Laboratory
;;; Professor Paul Cohen, Director.
;;; All rights reserved.

;;; Permission to use, copy, modify and distribute this software and its
;;; documentation is hereby granted without fee, provided that the above
;;; copyright notice of EKSL, this paragraph and the one following appear
;;; in all copies and in supporting documentation.
;;; EKSL makes no representation about the suitability of this software for any
;;; purposes.  It is provided "AS IS", without express or implied warranties
;;; including (but not limited to) all implied warranties of merchantability
;;; and fitness for a particular purpose, and notwithstanding any other
;;; provision contained herein.  In no event shall EKSL be liable for any
;;; special, indirect or consequential damages whatsoever resulting from loss
;;; of use, data or profits, whether in an action of contract, negligence or
;;; other tortuous action, arising out of or in connection with the use or
;;; performance of this software, even if EKSL is advised of the possiblity of
;;; such damages.

;;; For more information write to clasp-support@cs.umass.edu

;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;;
;;;  06-24-92 File Created.  (Carlson)
;;;
;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;; --*--

(in-package :clasp)

;;; --*--
;;; ***************************************************************************

(defun clasp-variable-reader-macro (stream char)
  (declare (ignore char))
  (let ((variable-name (read stream nil :eof t))
	(ch (peek-char nil stream nil :eof t))
	dataset-name)
    (when (not (eq variable-name :eof))
      (when (and (not (eq ch :eof))
		 (char= ch #\!))
	(read-char stream t nil t)
	(setf dataset-name (read stream t nil t)))
      (let ((variable (get-variable variable-name dataset-name nil)))
	(if variable
	    `',(variable-value variable)
	  nil)))))

;; This is commented out because we do this locally in the interface by rebinding the
;; readtable before the CLIM command loop starts. This means that this feature is not available
;; unless the CLIM interface is being used.

#+ignore
(set-macro-character #\! #'clasp-variable-reader-macro)

