(in-package "CLASP-INTERFACE")

(defvar *about-box* nil)

#+DEMO
(setf clasp::*clasp-version* (format nil "~A DEMO" clasp::*clasp-version*))

(defclass about-box (color-dialog 
                     windoid)
  ((clicks :initform 0))
  (:default-initargs
    :WINDOW-TYPE :DOUBLE-EDGE-BOX
    :VIEW-POSITION '(:TOP 75)
    :VIEW-SIZE #@(322 300) ; #@(340 300)
    :CLOSE-BOX-P NIL
    :VIEW-SUBVIEWS
    (append 
     (list
      #-PICT-DIALOG-ITEM
      (MAKE-DIALOG-ITEM
       'STATIC-TEXT-DIALOG-ITEM
       #@(184 54)
       #@(124 35)
       "CLASP" 'NIL
       :VIEW-FONT '("Times" 36 :SRCOR :PLAIN)
       :PART-COLOR-LIST `(:TEXT ,ccl::*red-color*))
      (MAKE-DIALOG-ITEM
       'STATIC-TEXT-DIALOG-ITEM
       #@(54 133)
       #@(234 20)
       "The Common Lisp Analytical"
       'NIL
       :VIEW-FONT
       '("Times" 18 :SRCOR :PLAIN))
      (MAKE-DIALOG-ITEM
       'STATIC-TEXT-DIALOG-ITEM
       #@(100 150)
       #@(144 27)
       "Statistics Package"
       'NIL
       :VIEW-FONT
       '("Times" 18 :SRCOR :PLAIN))
      (MAKE-DIALOG-ITEM
       'STATIC-TEXT-DIALOG-ITEM
       #@(21 192) ; #@(10 194)
       #@(292 50) ; #@(325 50)
       "" ; filled in later
       'NIL
       :VIEW-NICK-NAME 'text
       :VIEW-FONT
       '("Monaco" 9 :SRCOR :PLAIN))
      (MAKE-DIALOG-ITEM
       'STATIC-TEXT-DIALOG-ITEM
       #@(11 267)
       #@(263 15)
       "1994 Experimental Knowledge Systems Laboratory,"
       'NIL
       :VIEW-FONT
       '("Times" 12 :SRCOR :PLAIN)
       ;:PART-COLOR-LIST `(:TEXT ,ccl::*blue-color*)
       )
      (MAKE-DIALOG-ITEM
       'STATIC-TEXT-DIALOG-ITEM
       #@(11 280)
       #@(263 15)
       "University Of Massachusetts. All Rights Reserved."
       'NIL
       :VIEW-FONT
       '("Times" 12 :SRCOR :PLAIN)
       ;:PART-COLOR-LIST `(:TEXT ,ccl::*blue-color*)
       )
      #+PICT-DIALOG-ITEM
      (make-instance 'PICT-di ;'PICT-button-di
        :view-position #@(50 10)
        :PICT-name "Clasp Hand")
      #+PICT-DIALOG-ITEM
      (make-instance 'PICT-di ;'PICT-button-di
        :view-position #@(275 248)
        :PICT-name "Phoenix"
        ))
     (when clasp::*clasp-version*
       (list
        (MAKE-DIALOG-ITEM
         'STATIC-TEXT-DIALOG-ITEM
         (make-point (- 165 (truncate (string-width clasp::*clasp-version* '("Times" 12 :SRCOR :PLAIN)) 2))
                     173)
         #@(144 15)
         clasp::*clasp-version*
         'NIL
         :VIEW-FONT '("Times" 12 :SRCOR :PLAIN)
         :PART-COLOR-LIST `(:TEXT ,ccl::*red-color*)))))))

(defvar *clasp-application-creator* :CLSP)
       
(defun find-clasp-application-pathname ()
  (find-if #'(lambda (file)
               (and (eq (mac-file-creator file) *clasp-application-creator*)
                    (eq (mac-file-type file) :APPL)))
           (directory (make-pathname :defaults (user-homedir-pathname) :name :wild :type :wild))))

(defmethod window-close :after ((view about-box))
  (declare (ignore view))
  (setf *about-box* nil))

(defun display-about-box ()
  (if *about-box*
    (window-select *about-box*)
    (setf *about-box* (make-about-box)))
  (display-next-text *about-box* 0))

(defun make-about-box ()
  #+PICT-DIALOG-ITEM
  (let ((appl-path (find-clasp-application-pathname)))
    (when appl-path
      (open-res-file appl-path)))
  (make-instance 'about-box))

#|

(defun test-clasp-pict-di ()
  (open-res-file (find-clasp-application-pathname))
  (make-instance 'dialog
    :window-type :document
    :color-p t
    :view-position :centered
    :view-size #@(300 300)
    :window-title "PICT demo"
    :view-subviews
    (list
     (make-instance 'PICT-di ;'PICT-button-di
       :view-position #@(10 10)
       :PICT-name "Clasp Hand")
     (make-instance 'PICT-di ;'PICT-button-di
       :view-position #@(275 248)
       :PICT-name "Phoenix"
       ))))

|#

(defmethod display-next-text ((window about-box) &optional count)
  (case (setf (slot-value window 'clicks) 
              (or count (1+ (slot-value window 'clicks))))    
    (0
     (set-view-font (view-named 'text window) '("Times" 12 :SRCOR :PLAIN))
     (set-dialog-item-text 
      (view-named 'text window)
      "
Written by: David L. Westbrook, Matthew Schmill, 
                   Scott Anderson, and Adam Carlson."))
    (1 
     (set-view-font (view-named 'text window) '("Times" 10 :SRCOR :PLAIN))
     (set-dialog-item-text (view-named 'text window)
"Matt designed and implemented the interface.  Most of the statistical functions were written by Scott and Adam with random help from Westy and Matt.  Westy and Scott wrote the plotting package.
                      <click for more, option click to skip>"))
    (2
     (set-dialog-item-text (view-named 'text window)
"Most of the testing was done by Paul R. Cohen, EKSL director, Matt and Westy.  Additional beta testers include the Fall '94 Experimental Methods class and other members of the EKSL.
                      <click for more, option click to skip>"))
    
    (3
     (set-dialog-item-text (view-named 'text window)
"Finally, thanks to Matt Cornell for his interface design help and also to David Fisher who wrote the original Explorer version of CLASP.  There is also a CLIM-based version of CLASP which runs on Unix.  Adam and Westy did the original port to Unix."))
    (4
     (set-view-font (view-named 'text window) '("Monaco" 9 :SRCOR :PLAIN))
     (set-dialog-item-text (view-named 'text window)
                           "
Email to: clasp-support@cs.umass.edu
WWW: http://eksl-www.cs.umass.edu/clasp.html
       "))
    (t
     (window-hide window))))

;Interface: Matt Schmill, David L. Westbrook
;Statistics: Scott Anderson, David L. Westbrook, Matt Schmill
;Graphing: David L. Westbrook, Scott Anderson
;Testing: Paul Cohen, Matt Schmill, et. al.
;Thanks to: Adam Carlson, Matt Cornell"))
  
(defmethod view-click-event-handler :after ((window about-box) (where fixnum))
  (display-next-text window (if (option-key-p) 4)))

;;;
;;; liscence agreement
;;;

(defconstant *license-text* "CLASP FOR THE MACINTOSH statistical analysis system software.
Copyright (c) 1994, 1995 by the Applied Computing Systems Institute of
Massachusetts, Inc. (ACSIOM). All rights reserved. The CLASP FOR THE
MACINTOSH was provided by the Experimental Knowledge Systems
Laboratory (EKSL), University of Massachusetts Computer Science
Department, Amherst, Massachusetts.

NOTICE TO USER:

THIS IS A CONTRACT.  BY OPENING THIS PACKAGE AND/OR BY DOWNLOADING THE
SOFTWARE VIA FTP (FILE TRANSFER PROTOCOL) YOU ACCEPT ALL THE TERMS AND
CONDITIONS OF THIS AGREEMENT. If you do not agree with the terms and
conditions of this Agreement, return this media envelope, UNOPENED,
along with the rest of the package, to ACSIOM (P.O. Box 44, Amherst,
MA 01004), or, if transferred via ftp, permanently and immediately
delete and erase and destroy the original and all copies of the files,
without using, copying or distributing in any way the files

This package contains CLASP FOR THE MACINTOSH software and related
explanatory materials, if any (collectively, \"CLASP FOR THE
MACINTOSH\").  ACSIOM grants to you a non-exclusive license to use the
Software and Documentation, provided that you agree to the following:

This Agreement gives you, the LICENSEE, certain rights and
obligations. It is important that you read this Agreement before
opening this package and/or using CLASP FOR THE MACINTOSH. By using
CLASP FOR THE MACINTOSH, you indicate that you have read, understood,
and will comply with the terms.

Permission to use for internal, noncommercial, research-only purposes
is hereby granted. Title to copyright to CLASP FOR THE MACINTOSH and
to any associated documentation shall at all times remain with ACSIOM,
and LICENSEE agrees to preserve same. On any copies made for internal,
noncommercial, research-only purposes, LICENSEE must reproduce on each
copy the ACSIOM copyright notice and any other proprietary legends on
the original copy supplied by ACSIOM including a copy of this
Agreement. Any distribution of CLASP FOR THE MACINTOSH or any part
thereof is strictly prohibited without prior written consent of ACSIOM
LICENSEE agrees not to use separately any portion of CLASP FOR THE
MACINTOSH without prior written consent of ACSIOM.

YOU MAY NOT MODIFY, ADAPT, TRANSLATE, RENT, LEASE, LOAN, RESELL FOR
PROFIT, DISTRIBUTE, NETWORK, OR CREATE DERIVATIVE WORKS BASED UPON THE
SOFTWARE OR ANY PART THEREOF.

Nothing in this Agreement shall be construed as conferring rights to
use in advertising, publicity or otherwise any trademark of ACSIOM,
including the name of \"University of Massachusetts\" or \"ACSIOM.\"
Nothing in this Agreement shall be construed as conferring rights to
any ACSIOM patents or patent applications other than those rights
necessary to use CLASP FOR THE MACINTOSH under this Agreement.

CLASP FOR THE MACINTOSH IS PROVIDED \"AS IS\" AND ACSIOM MAKES NO
REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED. By way of example,
but not limitation, ACSIOM MAKES NO REPRESENTATIONS OR WARRANTIES OF
MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR PURPOSE OR THAT THE USE
OF THE LICENSED SOFTWARE COMPONENTS OR DOCUMENTATION WILL NOT INFRINGE
ANY PATENTS, COPYRIGHTS, TRADEMARKS OR OTHER RIGHTS, OR THAT THE
RESULTS OF CLASP OPERATIONS AND STATISTICAL TESTS ARE ACCURATE IN
EVERY CASE.

ACSIOM shall not be held liable for any liability nor for any direct,
indirect or consequential damages with respect to any claim by
LICENSEE or any third party on account of or arising from this
Agreement or use of this software.

ACSIOM's liability to LICENSEE for actual damages for any cause,
whatsoever, and regardless of the form of the action, will be limited
to the actual price LICENSEE paid ACSIOM for CLASP FOR THE MACINTOSH.

This Agreement is effective until terminated. This Agreement will
terminate immediately without notice from ACSIOM if you fail to comply
with any of its provisions. Upon termination, LICENSEE must destroy
CLASP FOR THE MACINTOSH and all copies thereof, and may terminate this
Agreement at any time by doing so.

LICENSEE agrees it will not export, directly or indirectly, CLASP FOR
THE MACINTOSH , or its documentation, in whole or in part, to any
country where such export is prohibited or restricted by the United
States Government without a license from the appropriate governmental
agency.")

(defconstant *default-license-width* 480)
(defconstant *default-license-height* 400)

(defclass license-viewer (windoid)
  ()
  (:default-initargs
    :close-box-p nil
    :view-size (make-point (min *screen-width* *default-license-width*)
                           (min *screen-width* *default-license-height*))
    #+CCL-3 :auto-position #+CCL-3 :centerMainScreen
    :window-type :tool
    :window-title "CLASP License Agreement"
    :window-show nil))

(defmethod initialize-instance :after ((lv license-viewer) &key)
  (let* ((size (view-size lv))
         (width (point-h size))
         (height (point-v size)))
    (add-subviews 
     lv
     (make-instance #-CCL-3 'ccl::scrolling-fred-dialog-item
                    #+CCL-3 'ccl::scrolling-fred-view
                    :view-nick-name 'text 
                    :h-scrollp (< width *default-license-width*)
                    :view-size (make-point (- width 15) (- height 40))
                    :view-position #@(0 0))
     (make-instance 'button-dialog-item 
       :view-position (make-point (- width 80) (- height 20)) ;#@(380 382)
       :dialog-item-text "I Decline" :border-p nil
       :dialog-item-action #'(lambda (b)
                               (declare (ignore b))
                               (return-from-modal-dialog nil)))
     (make-instance 'button-dialog-item
       :dialog-item-text "I Agree"
       :view-position (make-point 10 (- height 20)) ;#@(10 382) 
       :border-p nil
       :dialog-item-action #'(lambda (b)
                               (declare (ignore b))
                               (return-from-modal-dialog t)))))
  (window-show lv)
  (ed-insert-with-style (view-named 'text lv)
                        *license-text*
                        #+OLD
                        (apply #'format nil *license-text* (make-list 8 :initial-element #\")) 
                        NIL)
  (invalidate-view (view-named 'text lv)))

#+CCL-3
;; see the file CCL:Library:fred-compatibility if you want to know why this is necessary 
(defmethod ed-insert-with-style ((w ccl::fred-delegation-mixin) string style 
                                 &optional pos)
  (ed-insert-with-style (fred-item w) string style pos))

(defmethod set-view-position ((w ccl::fred-delegation-mixin) h &optional v)
  (set-view-position (fred-item w) h v))

(defparameter *_licensed_* NIL)

(defun do-license-agreement-and-about-box ()
  (when (not *_licensed_*)
    (if (modal-dialog (make-instance 'license-viewer))
      ;; save new prefs
      (progn (setf *_licensed_* t) (update-user-preferences-file))
      (quit-clasp)))
  ;; do about box
  (display-about-box))

;;;
;;; license encrypt system
;;;
#+WAIT
(defun encrypt (string)
  (let ((key (mod (reduce #'+ (map 'list #'char-code string)) 255)))
    (map 'string #'(lambda (c) (code-char (mod (+ key (char-code c)) 255))) string)))
#+WAIT
(defun validate (string1 string2)
  (let ((key (mod (reduce #'+ (map 'list #'char-code string1)) 255)))
    (string-equal string2 (map 'string #'(lambda (c) (code-char (mod (+ key (char-code c)) 255))) string1))))

;;; ---
;;; EOF