;;;
;;; openable-items.lisp
;;;

#|
================================================================
Purpose ========================================================
================================================================
Defines the high-level interface for "openable" items, i.e. items that
can be selected in a clasp-window then opened to show more/different
detail. Examples include graphs (show graphical plot) and datasets
(show variable contents).

FIX: Should be able to open clasp-commands so users can edit and/or
 re-run them. (We could show either a FRED window for editing the
 command or make a anova-one-way-dialog -like dialog based on the
 command.)


================================================================
Status =========================================================
================================================================
In-progress.


================================================================
Change history =================================================
================================================================
18-Jun-94 mc	Created.

|#

(in-package "CLASP-INTERFACE")

;;;
;;; Define open-related functions.
;;;

(defgeneric f-can-open-clasp-object (object)
  (:documentation "Returns non-nil if object can be opened via
open-clasp-object . Otherwise returns nil."))

(defmethod f-can-open-clasp-object ((object t))
  nil)


(defgeneric open-clasp-object (object)
  (:documentation "Opens object in a specialized window. Must be
specialized."))

(defmethod open-clasp-object :around ((object t))
  "Prints a message if object can't f-can-open-clasp-object .
Otherwise calls the next method."
  ;;
  (if (f-can-open-clasp-object object)
    (call-next-method)
    (message-dialog (format nil "Can't open ~A." object) :size #@(350 150))))


#|
(get-string-from-user "Edit Clasp Command"
 :initial-string (format nil "~S"
                         (sexp-clasp-command (first (l-history-selected-cw
                                                     (clasp-window-front ))))))
|#