;;;; -*- Mode:Common-Lisp; Package:COMMON-LISP-USER; Fonts:(MEDFNT); Base:10 -*-
;;;; *-* File: /usr/users/eksl/systems/clasp/clasp/development/interface/packages.lisp *-*
;;;; *-* Last-Edit: Monday, January 25, 1993  15:45:21; Edited-By: Westy *-* 
;;;; *-* Machine: Count (Explorer II, Microcode 489) *-*
;;;; *-* Software: TI Common Lisp System 6.49 *-*
;;;; *-* Lisp: TI Common Lisp System 6.49  *-*

;;;; **************************************************************************
;;;; **************************************************************************
;;;; *                                                                        *
;;;; *                  Package Definition for the MCL Interface              *
;;;; *                                                                        *
;;;; **************************************************************************
;;;; **************************************************************************
;;;
;;; Copyright (c) 1990 - 1994 University of Massachusetts
;;; Department of Computer Science
;;; Experimental Knowledge Systems Laboratory
;;; Professor Paul Cohen, Director.
;;; All rights reserved.

;;; Permission to use, copy, modify and distribute this software and
;;; its documentation is hereby granted without fee for non-commercial
;;; uses only (not for resale), provided that the above copyright
;;; notice of EKSL, this paragraph and the one following appear in all
;;; copies and in supporting documentation.

;;; EKSL makes no representation about the suitability of this software for any
;;; purposes.  It is provided "AS IS", without express or implied warranties
;;; including (but not limited to) all implied warranties of merchantability
;;; and fitness for a particular purpose, and notwithstanding any other
;;; provision contained herein.  In no event shall EKSL be liable for any
;;; special, indirect or consequential damages whatsoever resulting from loss
;;; of use, data or profits, whether in an action of contract, negligence or
;;; other tortuous action, arising out of or in connection with the use or
;;; performance of this software, even if EKSL is advised of the possibility of
;;; such damages.

;;; For more information write to clasp-support@cs.umass.edu

;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;;
;;;  09-06-93 File Created.  (Westy)
;;;
;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;; --*--

(in-package :COMMON-LISP-USER)

;;; --*--
;;; ***************************************************************************

(defpackage CLASP-INTERFACE
  (:use COMMON-LISP CCL
        #+OLD-VARS RTM
        CLASP
        EKSL-UTILITIES)
  #+CLASP-MCL-INTERFACE-DEBUG
  (:nicknames CI)
  (:export CLASP)
  (:import-from CLASP #+OLD-VARS .on. spy)
  (:import-from ccl class-prototype class-direct-superclasses
		class-direct-subclasses class-precedence-list)
  (:shadowing-import-from CLASP data name variable)
  (:shadowing-import-from EKSL-UTILITIES collect group 
                          without-interrupts copy))


(defpackage CLASP-USER
  (:use COMMON-LISP CCL CLASP-INTERFACE CLASP EKSL-UTILITIES
        #+OLD-VARS RTM)
  (:shadowing-import-from CLASP variable name)
  (:shadowing-import-from EKSL-UTILITIES copy without-interrupts)
  )

(require "QUICKDRAW")
(require "PICT-SCRAP")
(require "APPLEEVENT-TOOLKIT")

;; Stuff that has been moved to interface-mcl;contrib
#|

;; Moved this to here because it needed to be loaded before event-logging was loaded
;; since event-logging uses symbols in the AS package explicitly.  (Westy)

(require "APPLESCRIPT-LOADER"
         "ccl:contrib;applescript/appleevents;applescript-loader")

(require "DRAG-AND-DROP")
#+OLD
(require "OBJECT-DROPPER")

|#

;; from HELP.LISP file
#-CCL-3 (require "scrolling-fred-dialog-item")
;already loaded
;#+CCL-3 (require "scrolling-fred-view")



;;; ***************************************************************************
;;; EOF



