;;;
;;; status-view.lisp
;;;

#|
================================================================
Purpose ========================================================
================================================================
Defines the status-view class and methods.


================================================================
Status =========================================================
================================================================
In-progress.


================================================================
Change history =================================================
================================================================
22-May-94 mc	Created.

|#

(in-package "CLASP-INTERFACE")

(export '())

;;;
;;; Define status-view .
;;;

(defclass status-view (static-text-dialog-item)
  ()
  (:documentation "A general-purpose message area. Abbreviated 'sv'.")
  (:DEFAULT-INITARGS
    :view-nick-name 'status-view
    ;:view-position #@(3 2)              ; set by parent window
    ;:view-size #@(294 146)              ; set by parent window
    :VIEW-FONT '("Geneva" 9 :SRCOR :PLAIN)
    :dialog-item-text ""))


(defmethod show-status-view-string ((status-view status-view)
                                    (string string))
  "Displays string in status-view, replacing its previous display string."
  ;;
  (set-dialog-item-text status-view string))


(defmethod clear-status-view ((status-view status-view))
  "Clears status-view's previous display string."
  ;;
  (set-dialog-item-text status-view ""))

(defun update-status (string)
  (let ((cw (clasp-window-front)))
    (if cw (show-status-view-string cw string))))
