(in-package "CLASP-INTERFACE")

;; Moved some code from new-tables.lisp so it will be loaded earlier -
;; specifically the macro below.

;;;
;;; TPI - Interface Programmer's Interface
;;;

(defun make-table (table-type table-name &rest keys)
  (apply #'make-instance table-type :name table-name keys))

(defmacro make-composite-table ((table-name &key cw-titles table-titles) &rest table-forms)
  (let ((ts (gensym "Tables"))
        (cwts (gensym "Window-titles-"))
        (tits (gensym "Table-Titles-")))
    `(let* ((,ts (list ,@table-forms))
            (,cwts (or ,cw-titles (mapcar #'clasp::name ,ts)))
            (,tits (or ,table-titles (mapcar #'type-of ,ts))))
       (append (loop for tab in ,ts 
                     for cw in ,cwts append
                     (list cw tab))
               (list "Complete Results"
                     (make-instance 'composite-table :name ,table-name :tables ,ts :table-names ,tits))))))

;;;
;;; examples
;;;

#+ATABLE
(make-table 'anova-table "ANOVA" :row-names '(A TOT) :column-names '(SS DF MS F P)
              :table-data '((100.124 2 134.2124 1.65 0.7777)
                            (100.125666 2 134.212444)))

#+TEST
(make-composite-table ("Shank" :descriptors '("foo table" "bar table")
                       :table-names '("Foo" "Bar")) 
                      (make-table "foo") (make-table "bar"))