#|
*************************
* Transform Functions   *
* GUIs for Macintosh    *
* CLASP                 *
*************************

24-Jul-94 ms    gathered into volume

|#

(in-package "CLASP-INTERFACE")

#|
================================================================
add constant====================================================
================================================================
dialog box for clasp::add-constant

12-Jul-94 ms	Created.
20-Jul-94 ms    Beta finish.

|#
;;;
;;; Define Add-Constatnt-Dialog .
;;;

(defclass Add-Constant-Dialog (statistic-dialog-mixin dialog)
  ()
  (:documentation "A dialog for getting data for the
Add a Constant function.")
  (:default-initargs
    :WINDOW-TYPE :DOCUMENT
    :WINDOW-TITLE "Add a Constant"
    :help '*add-constant-help*
    :VIEW-SIZE #@(350 85)
    :VIEW-POSITION (best-spot 350 85)
    :VIEW-FONT '("Chicago" 12 :SRCOR :PLAIN)
    :VIEW-SUBVIEWS
    (LIST (make-instance 'variable-pop-up-menu #-CCL-3 :dialog-item-text #+CCL-3 :menu-title "To"
                         :view-nick-name 'x-var-item :allow-categorical-p nil
                         :view-position #@(9 15)
                         :view-size #@(225 20))         ;FIX: 20 is hardcoded
          (make-instance 'static-text-dialog-item :dialog-item-text "Constant"
                         :view-position #@(22 50))
          (make-instance 'number-entry-item :dialog-item-text "100"
                         :view-nick-name 'constant-number-item
                         :view-position #@(90 50)
                         :view-size #@(120 16))
          (make-instance 'compute-button-di :view-position #@(240 50)))))

#+ignore
(defmethod initialize-instance :after ((Add-Constant-Dialog Add-Constant-Dialog)
                                       &key)
  "old leftovers. throws in numbers selected in history view."
  (let* ((f-currently-selected-numbers 
          (f-some-numbers-selected-cw (clasp-window-front))))
    (if f-currently-selected-numbers
      (set-dialog-item-text (view-named 'constant-number-item Add-Constant-Dialog) 
                            (format NIL "~D" (car f-currently-selected-numbers))))))

(defmethod f-can-compute-statistics-dialog ((Add-Constant-Dialog Add-Constant-Dialog))
  "We can compute if there is at least one sample in the x-var-pop-up-menu."
  ;;
  (let* ((l-var-x (l-variables-var-pum (view-named 'x-var-item
                                                   Add-Constant-Dialog)))
         (f-can-compute l-var-x)
         (str-why-cant-compute (cond (f-can-compute "")
                                     ((null l-var-x)
                                      "Need at least one variable")
                                     (t "inexplicable reason not to work."))))
    (values f-can-compute
            str-why-cant-compute)))


(defmethod compute-statistics-dialog ((Add-Constant-Dialog Add-Constant-Dialog))
  (let* ((l-var-x (l-variables-var-pum (view-named 'x-var-item
                                                   Add-Constant-Dialog)))
         (const (number-item-value (view-named 'constant-number-item Add-Constant-Dialog))))
    (loop for x in l-var-x
          do (add-the-constant x const))))


(defmethod add-the-constant ((iv clasp::variable) k)
  "Calls add a constant on the arguments, saving
results in the history."
  ;;
  (let ((clasp-command (make-clasp-command
                        `(clasp::add-a-constant
                          ,iv
                          ,k)
                        :description
                        (list (list 'command 'clasp::add-a-constant)
                              (list 'variable iv)
                              (list 'constant k)))))
    (run-clasp-command clasp-command
                       :str-message "Adding a constant"
                       :f-update-dataset-view t)))


(defun Add-Constant-Dialog-make ()
  "Returns a new dialog instance for editing CLASP's
Add-a-constant function args."
  ;;
    (make-instance 'Add-Constant-Dialog))

;;;
;;; Define mul-constant-Dialog .
;;;

(defclass mul-constant-Dialog (statistic-dialog-mixin dialog)
  ()
  (:documentation "A dialog for getting data for the
Add a Constant function.")
  (:default-initargs
    :WINDOW-TYPE :DOCUMENT
    :WINDOW-TITLE "Multiply by Constant"
    :help '*mul-constant-help*
    :VIEW-SIZE #@(350 85)
    :VIEW-POSITION (best-spot 350 85)
    :VIEW-FONT '("Chicago" 12 :SRCOR :PLAIN)
    :VIEW-SUBVIEWS
    (LIST (make-instance 'variable-pop-up-menu #-CCL-3 :dialog-item-text #+CCL-3 :menu-title "To"
                         :view-nick-name 'x-var-item :allow-categorical-p nil
                         :view-position #@(9 15)
                         :view-size #@(225 20))         ;FIX: 20 is hardcoded
          (make-instance 'static-text-dialog-item :dialog-item-text "Constant"
                         :view-position #@(22 50))
          (make-instance 'number-entry-item :dialog-item-text "1.0"
                         :view-nick-name 'constant-number-item
                         :view-position #@(90 50)
                         :view-size #@(120 16))
          (make-instance 'compute-button-di :view-position #@(240 50)))))

(defmethod initialize-instance :after ((mul-constant-Dialog mul-constant-Dialog)
                                       &key)
  "old leftovers. throws in numbers selected in history view."
  (let* ((f-currently-selected-numbers 
          (f-some-numbers-selected-cw (clasp-window-front))))
    (if f-currently-selected-numbers
      (set-dialog-item-text (view-named 'constant-number-item mul-constant-Dialog) 
                            (format NIL "~D" (car f-currently-selected-numbers))))))

(defmethod f-can-compute-statistics-dialog ((mul-constant-Dialog mul-constant-Dialog))
  "We can compute if there is at least one sample in the x-var-pop-up-menu."
  ;;
  (let* ((l-var-x (l-variables-var-pum (view-named 'x-var-item
                                                   mul-constant-Dialog)))
         (f-can-compute l-var-x)
         (str-why-cant-compute (cond (f-can-compute "")
                                     ((null l-var-x)
                                      "Need at least one variable")
                                     (t "inexplicable reason not to work."))))
    (values f-can-compute
            str-why-cant-compute)))


(defmethod compute-statistics-dialog ((mul-constant-Dialog mul-constant-Dialog))
  (let* ((l-var-x (l-variables-var-pum (view-named 'x-var-item
                                                   mul-constant-Dialog)))
         (const (number-item-value (view-named 'constant-number-item mul-constant-Dialog))))
    (loop for x in l-var-x
          do (mul-the-constant x const))))


(defmethod mul-the-constant ((iv clasp::variable) k)
  "Calls add a constant on the arguments, saving
results in the history."
  ;;
  (let ((clasp-command (make-clasp-command
                        `(clasp::mul-by-constant
                          ,iv
                          ,k)
                        :description
                        (list (list 'command 'clasp::mul-by-constant)
                              (list 'variable iv)
                              (list 'constant k)))))
    (run-clasp-command clasp-command
                       :str-message "Multiplying by a constant"
                       :f-update-dataset-view t)))


(defun mul-Constant-Dialog-make ()
  "Returns a new dialog instance for editing CLASP's
mul-by-constant function args."
  ;;
    (make-instance 'mul-constant-Dialog))

;;;
;;; real sort
;;;

#| SORT variable
07-Aug-94  ms Created & changed from one-var-trans-dialog because it didn't work.
07-Aug-94  ms Beta finish. ;)

we'll eventually want to add options and stuff

|#

(defclass sort-dialog (statistic-dialog-mixin dialog)
  ()
  (:documentation "A dialog for getting data for the
sort-index function.")
  (:default-initargs
    :WINDOW-TYPE :DOCUMENT
    :WINDOW-TITLE "Sort Variable"
    :help '*sort-help*
    ;:VIEW-POSITION '(:TOP 128)
    :VIEW-SIZE #@(350 80)
    :VIEW-POSITION (best-spot 350 80)
    :VIEW-FONT '("Chicago" 12 :SRCOR :PLAIN)
    :VIEW-SUBVIEWS
    (LIST (make-instance 'variable-pop-up-menu #-CCL-3 :dialog-item-text #+CCL-3 :menu-title "Variables"
                         :view-nick-name 'x-var-item
                         :view-position #@(9 15)
                         :view-size #@(225 20))         ;FIX: 20 is hardcoded
          (make-instance 'compute-button-di :view-position #@(140 50)))))

(defmethod f-can-compute-statistics-dialog ((sort-dialog sort-dialog))
  (let* ((l-var-x (l-variables-var-pum (view-named 'x-var-item
                                                   sort-dialog)))
         (f-can-compute l-var-x)
         (str-why-cant-compute (cond (f-can-compute "")
                                     (t "Need a variable to sort."))))
    (values f-can-compute
            str-why-cant-compute)))

(defmethod compute-statistics-dialog ((sort-dialog sort-dialog))
  (let* ((l-var-x (l-variables-var-pum (view-named 'x-var-item
                                                   sort-dialog))))
    (loop for x in l-var-x
          do (compute-sort-index x x))))

(defun sort-dialog-make ()
  (make-instance 'sort-dialog))
#|

================================================================
sort-index======================================================
================================================================
dialog box for sort-index

12-Jul-94 ms	Created.
24-Jul-94 ms    Beta finish.

|#
;;;
;;; Define sort-index-dialog .
;;;

(defclass sort-index-dialog (statistic-dialog-mixin dialog)
  ()
  (:documentation "A dialog for getting data for the
sort-index function.")
  (:default-initargs
    :WINDOW-TYPE :DOCUMENT
    :WINDOW-TITLE "Sort by Index"
    :help '*sort-index-help*
    :VIEW-SIZE #@(350 100)
    :VIEW-POSITION (best-spot 350 100)
    :VIEW-FONT '("Chicago" 12 :SRCOR :PLAIN)
    :VIEW-SUBVIEWS
    (LIST (make-instance 'variable-pop-up-menu #-CCL-3 :dialog-item-text #+CCL-3 :menu-title "Variables"
                         :view-nick-name 'x-var-item
                         :view-position #@(9 15)
                         :view-size #@(225 20))         ;FIX: 20 is hardcoded
          (make-instance 'variable-pop-up-menu #-CCL-3 :dialog-item-text #+CCL-3 :menu-title "Index By"
                         :view-nick-name 'y-var-item
                         :view-position #@(9 40)
                         :view-size #@(225 20))         ;FIX: 20 is hardcoded
          (make-instance 'compute-button-di :view-position #@(140 70)))))

(defmethod f-can-compute-statistics-dialog ((sort-index-dialog sort-index-dialog))
  "We can compute if there is at least one sample in the x-var-pop-up-menu."
  ;;
  (let* ((l-var-x (l-variables-var-pum (view-named 'x-var-item
                                                   sort-index-dialog)))
         (l-var-y (l-variables-var-pum (view-named 'y-var-item
                                                    sort-index-dialog)))
         (f-can-compute (and l-var-x
                             l-var-y))
         (str-why-cant-compute (cond (f-can-compute "")
                                     ((null l-var-x)
                                      "Need at least one variable item")
                                     ((null l-var-y)
                                      "Need at least one index variable")
                                     (t "Must have equal amounts of variables and index variables."))))
    (values f-can-compute
            str-why-cant-compute)))


(defmethod compute-statistics-dialog ((sort-index-dialog sort-index-dialog))
  (let* ((l-var-x (l-variables-var-pum (view-named 'x-var-item
                                                   sort-index-dialog)))
         (l-var-y (l-variables-var-pum (view-named 'y-var-item
                                                   sort-index-dialog))))
    (if (= (length l-var-y) 1)
      (loop for x in l-var-x
            do (compute-sort-index x (car l-var-y)))
      (loop for x in l-var-x
            for y in l-var-y
            do (compute-sort-index x y)))))


(defmethod compute-sort-index ((x clasp::variable)
                                (y clasp::variable))
  "Calls sort on the arguments, saving
results in the history."
  ;;
  (let ((clasp-command (make-clasp-command
                        `(clasp::sort-variable
                          ,x
                          ,y)
                        :description
                        (list (list 'command 'clasp::sort-variable)
                              (list 'varaible x)
                              (list 'sort-by y)))))
    (run-clasp-command clasp-command
                       :str-message "Sorting Variables"
                       :f-update-dataset-view t)))


(defun sort-index-dialog-make ()
  "Returns a new dialog instance for editing CLASP's
sort-index function."
  ;;
  (make-instance 'sort-index-dialog))

;;;
;;;  Recode categorical dialog
;;;

#|

Recode categorical variable dialog code.
Note that this is NOT a statistical-dialog-mixin.

27-Jul-94 ms  Created
28-Jul-94 ms  Beta finish.

|#


(defclass recodable-item ()
  ((precoded-value
    :initform nil
    :initarg :precoded-value
    :type t
    :accessor precoded-value
    :documentation "The value of the item before recoding."
    )
   (recoded-value
    :initform nil
    :initarg :recoded-value
    :type t
    :accessor recoded-value
    :documentation "The value of the item after encoding."
    ))
  (:documentation "An item which can be recoded, and will be."))

(defvar *recode-item-font* '("Monaco" 9))

(defclass recode-item-table (sequence-dialog-item)
  ()
  (:documentation "A table used for recoding sequences.")
  (:DEFAULT-INITARGS
    :CELL-SIZE #@(117 11)
    :view-size #@(130 150)
    :SELECTION-TYPE :DISJOINT
    :TABLE-VSCROLLP T
    :table-sequence '()
    :TABLE-HSCROLLP NIL
    :view-font *recode-item-font*
    :table-print-function
    #'(lambda (item stream)
        (declare (ignore stream))
        (let ((string (if (typep item 'recodable-item)
                        (format nil "~8A -> ~8A" 
                                (trim-to-maxlen (precoded-value item) 8)
                                (trim-to-maxlen (recoded-value item) 8))
                        "uncodeable value")))
          (multiple-value-bind (ff ms) (font-codes *recode-item-font*)
            (with-font-codes ff ms
              (with-pstrs ((p-str string))
                (#_DrawString p-str))))))))

(defclass recode-var-stdi (variable-stdi)
  ()
  (:documentation "A static text dialog item which takes drops
like variable-stdi but then feeds the info to it's parent
recode-variable-dialog."))    

(defmethod receive-drop ((view recode-var-stdi) 
                           (object list) 
                           (pt-global integer))
  (let ((drops (remove-if-not 
                #'(lambda (item) (typep item 'clasp::variable)) object)))
    (if (not (null drops))
      (receive-drop view (car drops) pt-global))))

(defmethod receive-drop ((view recode-var-stdi) 
                           (object clasp::variable) 
                           (pt-global fixnum))
  (let ((dialog (view-container view)))
    (setf (dialog-variable dialog) object)
    (setf (variable-vset-stdi view) object)
    (reset-dialog-table dialog)
    (window-select dialog)))

(defclass recode-variable-dialog (window statistic-dialog-mixin)
  ((variable
    :initform nil
    :initarg :variable
    :type CLASP::variable
    :accessor dialog-variable
    :documentation "The variable being worked over."))
  (:documentation "A dialog for recoding categorical variables.")
  (:DEFAULT-INITARGS
    :window-title "Recode Categorical Variable"
    :HELP '*RECODE-HELP*
    :window-type :DOCUMENT
    :view-size #@(320 150)
    :view-position (best-spot 320 150)
    :view-subviews
    (list (make-instance 'recode-item-table 
            :view-nick-name 'recode-table)
          (make-instance 'recode-var-stdi :view-nick-name 'x-var-item
                         :VIEW-SIZE #@(120 13))
          (make-instance 'button-dialog-item
            :view-nick-name 'action-button
            :default-button NIL
            :dialog-item-text "Recode"
            :dialog-item-action
            #'(lambda (item)
                (recode-variable (view-container item))))
          (make-instance 'radio-button-dialog-item
            :dialog-item-text "Symbol"
            :view-nick-name 'symbol-radio-button)
          (make-instance 'radio-button-dialog-item
            :dialog-item-text "Number"
            :radio-button-pushed-p t
            :view-nick-name 'number-radio-button)
          (make-instance 'static-text-dialog-item
            :dialog-item-text "Recoded Type"
            :view-nick-name 'type-banner)
          (make-instance 'static-text-dialog-item
            :dialog-item-text "Recoded Value"
            :view-nick-name 'value-banner)
          (make-instance 'hack-text-item
            :dialog-item-text "enter value here"
            :view-nick-name 'value-well
            :view-size #@(100 13))
          (make-instance 'button-dialog-item
            :dialog-item-text "set"
            :view-nick-name 'set-button
            :default-button t
            :dialog-item-action
            #'(lambda (item)
                (set-recoded-values (view-container item)))))))

(defmethod initialize-instance :after ((dialog recode-variable-dialog) &key)
  (let ((selected-vars (items-in-dock 'x-var-dock :select-type :select-or-all)))
    (if selected-vars
      (receive-drop (view-named 'x-var-item dialog) selected-vars 0))))

(defmethod reset-dialog-table ((dialog recode-variable-dialog))
  (let ((recode-table (view-named 'recode-table dialog)))
    (deselect-cells recode-table)
    (set-window-title dialog "wait...")
    (set-table-sequence 
     recode-table
     (mapcar #'(lambda (thing)
                 (make-instance 'recodable-item 
                   :precoded-value thing
                   :recoded-value thing))
             ;; NOTE THAT WE USED TO SORT HERE !!
             (remove-duplicates (clasp::simplify (dialog-variable dialog)))))
    (set-window-title dialog "Recode Categorical Variable")
    ))

(defmethod window-size-parts ((dialog recode-variable-dialog))
  (let* ((table (view-named 'recode-table dialog))
         (varitem (view-named 'x-var-item dialog))
         (action (view-named 'action-button dialog))
         (symbolb (view-named 'symbol-radio-button dialog))
         (numberb (view-named 'number-radio-button dialog))
         (typeban (view-named 'type-banner dialog))
         (valban (view-named 'value-banner dialog))
         (value (view-named 'value-well dialog))
         (set (view-named 'set-button dialog))
         (table-width (and table (point-h (view-size table)))))
    (when (and table varitem action symbolb numberb typeban valban value set)  ;; 03-22-96 Added this. - Westy
      ;;table
      (set-view-position table 0 0)
      ;; varaible / recode action
      (frame-rect dialog table-width 0 (+ table-width (point-h (view-size dialog))) 26)
      (set-view-position varitem (+ 5 table-width) 2)
      (set-view-position action (+ 10 table-width (point-h (view-size varitem))) 2)
      ;; recode value / action / banner
      (set-view-position value (+ 5 table-width) 55)
      (set-view-size value (- (point-h (view-size dialog)) (+ table-width 10)) 15)
      (set-view-position valban (+ 5 table-width) 28)
      (set-view-position set (+ 10 table-width (point-h (view-size valban)))
                         28)
      ;; recode type radio button cluster
      (set-view-position typeban (+ 5 table-width) 80)
      (set-view-position numberb (+ 5 table-width) 96)
      (set-view-position symbolb (+ 5 table-width) 112)
      )))

(defmethod handle-arrow ((dialog recode-variable-dialog) char)
  "do the nasty hack on the sequence-view according to the char."
  (let* ((item (view-named 'recode-table dialog))
         (selected-cells (selected-cells item))
         (delta (if (equal char #\UpArrow) -1 1))
         )
    (mapcar #'(lambda (in) (cell-deselect item (point-h in) (point-v in)))
            selected-cells)
    (mapcar #'(lambda (in) (cell-select item (point-h in) (+ delta (point-v in))))
            selected-cells)))

(defmethod set-recoded-values ((dialog recode-variable-dialog))
  (let* ((recode-table (view-named 'recode-table dialog))
         (all-cells (table-sequence recode-table))
         (selected-cells (map 'list #'(lambda (cell) (elt all-cells
                                                         (point-v cell)))
                              (selected-cells recode-table)))
         (new-value (dialog-item-text (view-named 'value-well dialog))))
    (loop for x in selected-cells do
          (setf (recoded-value x) new-value))
    (if selected-cells
      (invalidate-view recode-table))
    (select-all dialog)
    ))

(defmethod recode-variable ((dialog recode-variable-dialog))
  (let* ((result-type (cond ((radio-button-pushed-p (view-named 'symbol-radio-button
                                                                dialog)) 'symbol)
                            (t 'number)))
         (variable (variable-vset-stdi (view-named 'x-var-item dialog)))
         (table-contents (table-sequence (view-named 'recode-table dialog)))
         (made-changes (not (equal (mapcar #'precoded-value table-contents)
                                   (mapcar #'recoded-value table-contents))))
         )
    (if (or made-changes
            (and (not made-changes)
                 (y-or-n-dialog "You haven't changed anything. Continue ?")))
      (cond 
        ((eq result-type 'symbol) (recode-as-symbols variable table-contents))
        ((eq result-type 'number) (recode-as-numbers variable table-contents))
        (t (warn "big trouble in little china."))))))

(defun recode-as-symbols (variable table)
  (let* ((start-values (mapcar #'precoded-value table))
         (finish-values (mapcar #'(lambda (ri) 
                                    (read-from-string (substitute #\- #\space (recoded-value ri))))
                                table))
         (clasp-command (make-clasp-command 
                         `(let ((v (clasp::recode-categorical
                                    ,variable
                                    ',start-values
                                    ',finish-values)))
                            (setf (slot-value v 'clasp::type) :categorical)
                            v)
                         :description
                         (list (list 'command 'clasp::recode-categorical)
                               (list 'variable variable)
                               (list 'as 'symbols))))
         )
    (run-clasp-command clasp-command
                       :str-message "Recoding categorical variable...."
                       :f-update-dataset-view t)))

(defun recode-as-numbers (variable table)
  (let* ((start-values (mapcar #'precoded-value table))
         (finish-values (mapcar #'(lambda (item)
                                    (if (typep item 'string)
                                      (parse-float item :report-errors t)
                                      (if (typep item 'number)
                                        item
                                        :illegal-type)))
                                (mapcar #'recoded-value table)))
         (clasp-command (make-clasp-command
                         `(let ((v (clasp::recode-categorical
                                    ,variable
                                    ',start-values
                                    ',finish-values)))
                            (setf (slot-value v 'clasp::type) :numerical)
                            v)
                         :description
                         (list (list 'command 'clasp::recode-categorical)
                               (list 'variable variable)
                               (list 'as 'numbers))))
         )
    (if (or (member :unparsable-number finish-values)
            (member :illegal-type finish-values))
      (message-dialog "There are non-numeric recodes entered. Please recode them
or use the symbol recode type." :ok-text "sure")
      (run-clasp-command clasp-command
                         :str-message "Recoding categorical variable...."
                         :f-update-dataset-view t))))

;;;
;;; Reassign-bins-dialog.lisp
;;;

#|
=====================================================================
Dialog box for reassigning bins in CLASP.


28-Jul-94 ms    Created
29-Jul-94 ms    Beta finish

|#

(defclass rebin-variable-stdi (variable-stdi)
  ()
  (:documentation "A variable-stdi that updates the information
needed in the rebin-dialog."))

(defmethod receive-drop :after ((stdi rebin-variable-stdi)
                                  (object clasp::variable)
                                  (pt-global fixnum))
  (if (eql (slot-value object 'clasp::type) :categorical)
    (progn
      (setf (variable-vset-stdi stdi) NIL)
      (set-dialog-item-text stdi "<NONE>")
      (gui-warn "Categorical data cannot be binned. Grouping can be accomplished using Recode Categorical."))
    (set-rebin-bounds (view-container stdi))))

(defclass rebin-mode-selector (radio-button-dialog-item)
  ()
  (:documentation "A radio button that disables appropriate dialog items
in the reassign bins dialog.")
  (:DEFAULT-INITARGS
    :dialog-item-action 'mode-select))

(defmethod initialize-instance :after ((rebin-mode-selector rebin-mode-selector) &key)
  '())

(defun mode-select (selector)
  "disable the number-entry items that don't apply, etc..."
  (let ((nick-name (view-nick-name selector))
        (num-item (view-named 'numbins-nei (view-container selector)))
        (num-tag (view-named 'numbins-banner (view-container selector)))
        (siz-tag (view-named 'binsize-banner (view-container selector)))
        (siz-item (view-named 'binsize-nei (view-container selector))))
    (if (equal nick-name 'number-rb)
      (progn
        (dialog-item-enable num-item)
        (dialog-item-enable num-tag)
        (dialog-item-disable siz-tag)
        (dialog-item-disable siz-item)
        )
      (progn
        (dialog-item-disable num-item)
        (dialog-item-disable num-tag)
        (dialog-item-enable siz-tag)
        (dialog-item-enable siz-item)
        ))))

(defclass rebin-dialog (window statistic-dialog-mixin)
  ()
  (:documentation "The dialog window that lets you rebin
a variable the easy way.")
  (:DEFAULT-INITARGS
    :window-type :document
    :window-title "Reassign Bins"
    :HELP '*REBIN-HELP*
    :view-size #@(300 150)
    :view-position (best-spot 300 150)
    :view-subviews 
    (list (make-instance 'static-text-dialog-item
            :view-nick-name 'x-var-banner
            :dialog-item-text "Variable :")
          (make-instance 'rebin-variable-stdi
            :view-nick-name 'x-var-item
            :view-size #@(140 13))
          (make-instance 'rebin-mode-selector
            :view-nick-name 'number-rb
            :dialog-item-text "Use # of bins")
          (make-instance 'rebin-mode-selector
            :view-nick-name 'size-rb
            :dialog-item-text "Use bin size")
          (make-instance 'static-text-dialog-item
            :dialog-item-text "No lower bound."
            :view-size #@(140 13)
            :view-nick-name 'lower-bound-banner)
          (make-instance 'static-text-dialog-item
            :dialog-item-text "No upper bound."
            :view-size #@(140 13)
            :view-nick-name 'upper-bound-banner)
          (make-instance 'compute-button-di
            :view-nick-name 'compute)
          (make-instance 'static-text-dialog-item
            :dialog-item-text "Start bin"
            :view-nick-name 'start-banner)
          (make-instance 'number-entry-item
            :dialog-item-text "0"
            :allow-floats t
            :view-size #@(64 13)
            :view-nick-name 'start-nei)
          (make-instance 'static-text-dialog-item
            :dialog-item-text "End bin"
            :view-nick-name 'end-banner)
          (make-instance 'number-entry-item
            :dialog-item-text "0"
            :allow-floats t
            :view-size #@(64 13)
            :view-nick-name 'end-nei)
          (make-instance 'static-text-dialog-item
            :dialog-item-text "# of bins"
            :view-nick-name 'numbins-banner)
          (make-instance 'number-entry-item
            :dialog-item-text "0"
            :allow-floats nil
            :view-size #@(64 13)
            :allow-negatives nil
            :view-nick-name 'numbins-nei)
          (make-instance 'static-text-dialog-item
            :dialog-item-text "Bin size"
            :view-nick-name 'binsize-banner)
          (make-instance 'number-entry-item
            :dialog-item-text "0"
            :allow-floats t
            :allow-negatives nil
            :view-size #@(64 13)
            :view-nick-name 'binsize-nei))))
            
(defmethod initialize-instance :after ((dialog rebin-dialog) &key)
  (mode-select (view-named 'number-rb dialog)))

(defmethod set-rebin-bounds ((dialog rebin-dialog))
  "fills in the bounds static text items in the rebin dialog."
  (let* ((variable (variable-vset-stdi (view-named 'x-var-item dialog)))
         (max (if variable (clasp::maximum (clasp::simplify variable))))
         (min (if variable (clasp::minimum (clasp::simplify variable))))
         )
    (set-dialog-item-text (view-named 'upper-bound-banner dialog)
                          (if max
                            (format nil "Max : ~,3F" max)
                            "No upper bound."))
    (set-dialog-item-text (view-named 'lower-bound-banner dialog)
                          (if min
                            (format nil "Min : ~,3F" min)
                            "No lower bound."))
    (set-dialog-item-text (view-named 'start-nei dialog)
                          (format nil "~,5F" min))
    (set-dialog-item-text (view-named 'end-nei dialog)
                          (format nil "~,5F" max))))

(defmethod window-size-parts :after ((dialog rebin-dialog))
  (let* ((varbanner (view-named 'x-var-banner dialog))
         (variable (view-named 'x-var-item dialog))
         (lb (view-named 'lower-bound-banner dialog))
         (ub (view-named 'upper-bound-banner dialog))
         (startb (view-named 'start-banner dialog))
         (starte (view-named 'start-nei dialog))
         (endb (view-named 'end-banner dialog))
         (ende (view-named 'end-nei dialog))
         (numb (view-named 'numbins-banner dialog))
         (nume (view-named 'numbins-nei dialog))
         (sizeb (view-named 'binsize-banner dialog))
         (sizee (view-named 'binsize-nei dialog))
         (unum (view-named 'number-rb dialog))
         (usize (view-named 'size-rb dialog))
         (compute (view-named 'compute dialog))
         )
    (when (and varbanner variable lb ub startb starte
               endb ende numb nume sizeb sizee unum usize compute)
      (set-view-position varbanner #@(50 5))
      (set-view-position variable #@(140 5))
      (set-view-position lb #@(5 25))
      (set-view-position ub #@(150 25))
      (set-view-position startb #@(5 50))
      (set-view-position starte #@(75 50))
      (set-view-position endb #@(150 50))
      (set-view-position ende #@(225 50))
      (set-view-position numb #@(5 75))
      (set-view-position nume #@(75 75))
      (set-view-position sizeb #@(150 75))
      (set-view-position sizee #@(225 75))
      (set-view-position unum #@(30 100))
      (set-view-position usize #@(150 100))
      (set-view-position compute #@(120 125))
      )))

(defmethod f-can-compute-statistics-dialog ((rebin-dialog rebin-dialog))
  (variable-vset-stdi (view-named 'x-var-item rebin-dialog)))

(defun rebin-args-binsize (start end binsize)
  (let ((bin-limits '())
        (curr start))
    (loop while (<= curr end) do
          (setq bin-limits (append bin-limits (list curr)))
          (setq curr (+ curr binsize)))
    (values bin-limits (append bin-limits (list (1+ end))))))

(defun rebin-args-numbins (start end numbins)
  (let* ((binsize (/ (- end start) (1- numbins)))
         (bin-limits '()))
    (dotimes (x numbins)
      (setq bin-limits (append bin-limits (list (+ start (* x binsize))))))
    (values bin-limits (append bin-limits (list (1+ end))))))

(defun reassign-bins (variable limits names)
  (let ((clasp-command (make-clasp-command 
                        `(clasp::rebin
                          ,variable
                          ',limits
                          ',names)
                        :description
                        (list (list 'command 'clasp::rebin)
                              (list 'bin-limits limits)
                              (list 'bin-names names)))))
    (run-clasp-command clasp-command
                       :str-message "Reassigning bins...."
                       :f-update-dataset-view t)))

(defmethod compute-statistics-dialog ((rebin-dialog rebin-dialog))
  (let* ((start (number-item-value (view-named 'start-nei rebin-dialog)))
         (end (number-item-value (view-named 'end-nei rebin-dialog)))
         (compute-type (if (radio-button-pushed-p (view-named 'number-rb rebin-dialog))
                         :use-numbins
                         :use-binsize))
         (compute-arg (if (equal compute-type :use-numbins)
                        (number-item-value (view-named 'numbins-nei rebin-dialog))
                        (number-item-value (view-named 'binsize-nei rebin-dialog)))))
    (multiple-value-bind (bin-limits bin-names)
                         (if (equal compute-type :use-numbins)
                           (rebin-args-numbins start end compute-arg)
                           (rebin-args-binsize start end compute-arg))
      (reassign-bins (variable-vset-stdi (view-named 'x-var-item rebin-dialog)) 
                     bin-limits
                     bin-names))))

(defun rebin-dialog-make ()
  (make-instance 'rebin-dialog))

;;;
;;; User defined transform
;;;

(defclass user-defined-dialog (statistic-dialog-mixin dialog)
  ()
  (:documentation "A dialog for getting data for user defined
functions. nothing very zany here.")
  (:default-initargs
    :WINDOW-TYPE :DOCUMENT-WITH-GROW
    :WINDOW-TITLE "User Defined Transform"
    :HELP '*USER-DEFINED-HELP*
    :VIEW-SIZE #@(250 140)
    :VIEW-POSITION (best-spot 250 140)
    :VIEW-FONT '("Chicago" 12 :SRCOR :PLAIN)
    :VIEW-SUBVIEWS
    (LIST (make-instance 'editable-text-dialog-item :dialog-item-text "<expression>"
                         :view-position #@(9 10) :allow-returns t :allow-tabs t
                         :view-size #@(230 60)
                         :view-nick-name 'expression)
          (make-instance 'static-text-dialog-item :dialog-item-text "On"
                         :view-position #@(9 82) :view-nick-name 'on-label
                         :view-size #@(30 20))         ;FIX: 20 is hardcoded
          (make-instance 'dataset-stdi :view-nick-name 'dataset
                         :view-position #@(40 82)
                         :view-size #@(150 18))
          (make-instance 'compute-button-di :view-nick-name 'compute :view-position #@(90 100)))))

(defmethod window-size-parts ((window user-defined-dialog))
  (let* ((size (view-size window))
         (hor  (point-h size))
         (ver  (point-v size))
         (exp  (view-named 'expression window))
         (com  (view-named 'compute window))
         (label (view-named 'on-label window))
         (dset (view-named 'dataset window)))
    (when (and exp com label dset) ;; 03-22-96 Added this. - Westy
      (set-view-size exp (- hor 20) (- ver 45))
      (set-view-position exp 10 10)
      (set-view-position com (- hor 90) (- ver 25))
      (set-view-position label 10 (- ver 25))
      (set-view-position dset 40 (- ver 25))
      (set-view-size dset (- hor 140) 18))))

(defmethod f-can-compute-statistics-dialog ((dialog user-defined-dialog))
  "can we do this ?"
  (let* ((dataset (dataset-dset-stdi (view-named 'dataset dialog)))
         (expression (read-from-string (dialog-item-text (view-named 'expression dialog))))
         (can-compute (and dataset (> (length expression) 0)))
         (why-cant-compute (cond ((null dataset) "no dataset specified")
                                 (t "No function to apply."))))
    (values can-compute why-cant-compute)))

(defmethod compute-statistics-dialog ((dialog user-defined-dialog))
  (let ((dataset (dataset-dset-stdi (view-named 'dataset dialog)))
        (expression (read-from-string (dialog-item-text (view-named 'expression dialog)))))
    (user-defined expression dataset)))

(defun user-defined (expression dataset)
  (let* ((clasp-command (make-clasp-command `(clasp::formula
                                              ,dataset
                                              ',expression)
                                            :description
                                            (list (list 'command
                                                        'clasp::formula)
                                                  (list 'dataset
                                                        dataset)
                                                  (list 'expression
                                                        expression)))))
    (run-clasp-command clasp-command
                       :str-message "Applying user defined function...."
                       :f-update-dataset-view t)))

(defun make-user-defined-dialog ()
  (make-instance 'user-defined-dialog))
                                             
;;;
;;;  smooth variable (not 4253h)
;;;

;;;  15-Sep-94 ms   created

(defclass smooth-dialog (statistic-dialog-mixin dialog)
  ()
  (:documentation "Dialog for doing custom style smooths.")
  (:default-initargs
    :view-size #@(350 90) ;#@(250 90)
    :view-position (best-spot 350 90)
    :help '*smooth-help*
    :window-title "Smooth Variable"
    :view-subviews (list
                    (make-instance 'variable-pop-up-menu #-CCL-3 :dialog-item-text #+CCL-3 :menu-title "X(s) "
                                   :view-position #@(5 5) :allow-categorical-p nil
                                   :view-size #@(240 20)
                                   :view-nick-name 'x-var-item)
                    (make-instance 'pop-up-menu #-CCL-3 :dialog-item-text #+CCL-3 :menu-title "Type "
                                   :menu-items (list (make-instance 'menu-item :menu-item-title "Median")
                                                     (make-instance 'menu-item :menu-item-title "Mean"))
                                   :view-position #@(5 30)
                                   :view-size #@(115 20)
                                   :view-nick-name 'smooth-type)
                    (make-instance 'pop-up-menu #-CCL-3 :dialog-item-text #+CCL-3 :menu-title "Window"
                                   :menu-items (mapcar #'(lambda (item) (make-instance 'menu-item :menu-item-title (format nil "~D" item)))
                                                       '(2 3 4 5))
                                   :view-position #@(130 30)
                                   :view-size #@(115 20)
                                   :view-nick-name 'window-size)
                    (make-instance 'compute-button-di :view-position #@(140 60)))))

(defmethod f-can-compute-statistics-dialog ((smooth-dialog smooth-dialog))
  (let ((f-can-compute (l-variables-var-pum (view-named 'x-var-item smooth-dialog)))
        (str-why-cant-compute "Need at least one variable to transform."))
    (values f-can-compute str-why-cant-compute)))

(defmethod compute-statistics-dialog ((smooth-dialog smooth-dialog))
  (let* ((vars (l-variables-var-pum (view-named 'x-var-item smooth-dialog)))
         (type (menu-item-title (selected-item (view-named 'smooth-type smooth-dialog))))
         (wind (menu-item-title (selected-item (view-named 'window-size smooth-dialog))))
         (function (read-from-string
                    (format nil "clasp::smooth-~A-~D" type wind))))
    (dolist (x vars)
      (smooth-command x function (format nil "~A ~D of ~A" type wind (clasp::name x))))))

(defmethod smooth-command (variable function name)
  (if (not (fboundp function))
    (gui-warn (format nil "~S is not a legal smoothing funciton." function))
    (run-clasp-command 
     (make-clasp-command
      `(clasp::add-variable-to-dataset (clasp::variable-dataset ,variable)
                                       (,function (clasp::simplify ,variable))
                                       ,name)
      :description (list (list 'command function)
                         (list 'x-args variable)))
     :str-message (format nil "Computing ~:(~A~)...." function)
     :f-update-dataset-view t)))

(defun smooth-dialog-make ()
  (make-instance 'smooth-dialog))