;;; -*- Mode: LISP; Syntax: Common-Lisp; Base: 10; Package:CLASP-INTERFACE -*-

(in-package :clasp-interface)

(defmacro define-result-display (class)
  `(defmethod display ((self ,class) stream)
     (flet ((format-slot (name)
			 (let ((value (slot-value self name)))
			   (formatting-cell
			    (stream :align-x :right)
			    (present value 'nice-real :stream stream))))
	    (format-value (value)
			  (formatting-cell
			   (stream :align-x :right)
			   (present value 'nice-real :stream stream)))
	    (format-label (value)
			  (formatting-cell
			   (stream :align-x :right)
			   (with-text-style
			    (*label-text-style* stream)
			    (if (numberp value)
				(present value 'nice-real :stream stream)
			      (format stream "~a" value)))))
	    (format-percent (numerator denominator)
			    (formatting-cell
			     (stream :align-x :right)
			     (present (/ numerator denominator .01)
				      'short-nice-real :stream stream)
			     (format stream "%")))
	    (format-percent-label (numerator denominator)
				  (formatting-cell
				   (stream :align-x :right)
				   (with-text-style
				    (*label-text-style* stream)
				    (present (/ numerator denominator .01)
					     'short-nice-real :stream stream)
				    (format stream "%")))))
	   ,@body)))

