;;;; -*- Mode:Common-Lisp; Package:CL-USER; Fonts:(MEDFNT); Base:10 -*-
;;;; *-* File: Titanic: /usr/users/eksl/mac-files/clips/defsys.lisp *-*
;;;; *-* Last-edit: Thursday, January 28, 1993  19:13:02; Edited-By: Westy *-* 
;;;; *-* Machine: Count (Explorer II, Microcode 489) *-*
;;;; *-* Software: TI Common Lisp System 6.49 *-*
;;;; *-* Lisp: TI Common Lisp System 6.49  *-*

;;;; **************************************************************************
;;;; **************************************************************************
;;;; *                                                                        *
;;;; *                            System Definition                           *
;;;; *                                                                        *
;;;; **************************************************************************
;;;; **************************************************************************
;;;
;;; Written by: David L. Westbrook
;;;             Experimental Knowledege Systems Laboratory
;;;             Paul R. Cohen, Principal Investigator
;;;             David L. Westbrook, Systems Manager
;;;             David M. Hart, Laboratory Manager
;;;             Department of Computer and Information Science
;;;             University of Massachusetts
;;;             Amherst, Massachusetts 01003.
;;;
;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;;
;;;  01-19-93 File Created.  (Westy)
;;;
;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;; --*--

(in-package #+CLTL2 COMMON-LISP-USER #-CLTL2 'USER)

;;; --*--
;;; ***************************************************************************

#+(or Allegro Lucid MCL)
(assert (find-package 'make)
	nil
	"~%I really need the Public Domain DEFSYSTEM-Facility in Package MAKE"
	)

#+Defsystem
(setf portable-defsystem:*load-all-before-compile* t)


#+Defsystem
(defun merge-binary-defaults (pathname)
  (make-pathname :defaults 
                 (merge-pathnames *default-binary-path* 
                                  pathname)
		 :host "EKSL"))

#+Defsystem
(portable-defsystem:defsystem clasp-interface
 #-(or allegro lucid)
 (:default-pathname "Eksl:clasp;interface;"
  :default-binary-pathname (merge-binary-defaults "Eksl:clasp;interface;"))
 #+allegro ; use this until we get the logical pathname stuff to work completely
 (:default-pathname "/usr/users/eksl/mac-files/clasp/v3dev/interface/"
  :default-binary-pathname "/usr/users/eksl/mac-files/clasp/v3dev/interface/allegro-binaries/")
 #+lucid ; use this until we get the logical pathname stuff to work completely
 (:default-pathname "/usr/users/eksl/mac-files/clasp/v3dev/interface/"
  :default-binary-pathname "/usr/users/eksl/mac-files/clasp/v3dev/interface/lucid-binaries/")

 ("packages")
 ("utilities")
 ("icon-defs")
 ("icon")
 ("define-icons")
 ("class-defs")
 ("frame")
 ("defstat")
 ("commands")
 ("graph-commands")
 ("stat-commands")
 ("data-manipulation-commands")
 ("transform-commands")
 ("test-commands")
 ("sampling-commands")
 #+ignore
 ("test-code"))

#+DEFSYSTEM
(defvar *clasp-interface-defsys-load-action* nil)

#+DEFSYSTEM
(defun compile-and-load-clasp-interface (&rest options)
  (apply 'portable-defsystem:compile-system 'clasp-interface options)
  (apply 'portable-defsystem:load-system 'clasp-interface options))

#+DEFSYSTEM
(unless (member :NOLOAD *clasp-interface-defsys-load-action*)
  (if (or (member :COMPILE *clasp-interface-defsys-load-action*)
          (yes-or-no-p "Compile and load CLASP Interface?"))
    (compile-and-load-clasp-interface)
    (when (or (member :LOAD *clasp-interface-defsys-load-action*)
              (yes-or-no-p "Simply load CLASP Interface?"))
      (portable-defsystem:load-system 'clasp-interface))))
  
;;; ***************************************************************************
;;; EOF
