;;; -*- Mode: LISP; Syntax: Common-Lisp; Base: 10; Package:CLASP-INTERFACE -*-

(in-package :CLASP-INTERFACE)

;;;****************************************************************
;;; copied some defs from icons.lisp
;;;
;;; This contains code for bitmap (Clim 'pattern') icons including
;;; stationary icons, mouse-movability, command-icons (buttons),
;;; and dragged-icons (drag icon and execute function on a target)
;;;
;;;****************************************************************


(defclass icon (clasp::named-object)
  ((file :initform nil :initarg :file :accessor file)
   (bitmap :initform nil :initarg :bitmap :accessor bitmap)
   (presentation :initform nil :initarg :presentation :accessor presentation)
   (label-p :initform t :initarg :label-p :accessor label-p)
   (height :initform nil :initarg :height :accessor height)
   (width :initform nil :initarg :width :accessor width)
   (x :initform 0 :initarg :x :accessor x)
   (y :initform 0 :initarg :y :accessor y)
   (icon-window :initform nil :initarg :icon-window :accessor icon-window))
  )

(defclass command-icon (icon)		; AKA a "button"
	  ((command-form :initform nil :initarg :command-form
			     :accessor command-form)
	   (command-documentation :initform (make-string 0)
			  :initarg :command-documentation
			  :accessor command-documentation)
	   ))

(defclass dragged-icon (command-icon)
	  ((target :initform nil
		   :initarg :target
		   :accessor target)
	   (target-form :initform nil
			    :initarg :target-form
			    :accessor target-form)
	   ))