;;;; -*- Mode:Common-Lisp; Package:CLASP-INTERFACE; Base:10 -*-

(in-package :clasp-interface)

(define-condition invalid-coloring-variable (clasp::clasp-error) ()
  (:report "Cannot make colored graph with selected data.")
  (:documentation
   "This error is signaled when an attempt is made to create a colored graph
using invalid data.  Colored graphs must be made from clasp variables, and all the variables, both for the data and the coloring variable, must come from the same dataset."))

(define-condition mismatched-mapped-argument-length (clasp::clasp-warning) ()
  (:report "Cannot map over arguments of differing length.")
  (:documentation
   "Mapped arguments must all be of the same length."))
