;;;; -*- Mode:Common-Lisp; Package:CLASP-INTERFACE; Base:10 -*-

(in-package :clasp-interface)

;;;----------------------------------------------------------------------------

(defclass expanded-display-mixin ()
  ((expanded-display-p :initarg :expanded-display-p
		       :type boolean
		       :accessor expanded-display-p)))

(defmethod initialize-instance :after ((self expanded-display-mixin) &rest initargs)
  (setf (expanded-display-p self) (eq (display-option self) :notebook)))

(defmethod expanded-display-p ((self t))
  (eq (display-option self) :notebook))

;;;----------------------------------------------------------------------------

(define-presentation-to-command-translator expand
  (result com-expand clasp
			  :gesture :edit
			  :echo nil
			  :tester
			  ((object)
			   (not (expanded-display-p object))))
  (object)
  (list object))

(define-clasp-command (com-expand :command-table clasp-data-manipulation
				  :name t :menu t)
  ((object 'result))
  (when (slot-exists-p object 'expanded-display-p)
	(setf (expanded-display-p object) t)
	(present-with-update object
			     :stream *standard-output* :view +dialog-view+)))

(define-presentation-to-command-translator collapse
  (result com-collapse clasp
	  :gesture :edit
	  :echo nil
	  :tester
	  ((object)
	   (expanded-display-p object)))
  (object)
  (list object))

(define-clasp-command (com-collapse :command-table clasp-data-manipulation
				    :name t :menu t)
  ((object 'result))
  (when (slot-exists-p object 'expanded-display-p)
	(setf (expanded-display-p object) nil)
	(present-with-update object
			     :stream *standard-output* :view +dialog-view+)))
