;;;; -*- Mode:Common-Lisp; Package:COMMON-LISP-USER; Fonts:(MEDFNT); Base:10 -*-
;;;; *-* File: /usr/users/eksl/systems/utils/dev/package.lisp *-*
;;;; *-* Last-edit: Tuesday, May 16, 1995  16:17:26; Edited-By: anderson *-* 
;;;; *-* Machine: Christa (Explorer II, Microcode 489) *-*
;;;; *-* Software: TI Common Lisp System 6.49 *-*

;;;; **************************************************************************
;;;; **************************************************************************
;;;; *                                                                        *
;;;; *          Package Definitions for the Lisp Extensions System            *
;;;; *                                                                        *
;;;; **************************************************************************
;;;; **************************************************************************
;;;
;;; Copyright (c) 1994 University of Massachusetts
;;; Department of Computer Science
;;; Experimental Knowledge Systems Laboratory
;;; Professor Paul Cohen, Director.
;;; All rights reserved.

;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;;
;;;  03-17-92 File Created.  (Westy)
;;;  05-05-95 Renamed to EKSL-UTILITIES.  (Westy)
;;;  05-06-95 Changed the :use list to :common-lisp, so we don't accidentally
;;;           step on vendor extensions.  When we use vendor extensions, such as
;;;           without-interrupts, we should explicitly import them. (Anderson)
;;;  05-12-95 Added some more imports for some of the See-Los You-Tils (ugh).
;;;           (Westy)
;;;  06-08-95 Added definition of EKSL-USER package.  (Westy)
;;;
;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;; --*--

(in-package :COMMON-LISP-USER)

(defpackage :eksl-utilities
  (:nicknames :u :eksl-utils)
  (:use #-CLIM COMMON-LISP #+CLIM CLIM #+CLIM CLIM-LISP #+Explorer CLOS #+MCL CCL)
  #+CLIM
  (:shadow POINTP POINT-Y POINT POINT-X)
  #+MCL
  (:shadow line)

 #+(or LCL4.0 LCL4.1)
  (:import-from clos class-finalized-p class-precedence-list
		     class-direct-superclasses class-direct-subclasses
                     class-slots slot-definition-name)

  #+(or LCL4.0 LCL4.1)
  (:import-from lucid load-time-value)
  
  #+Lucid ;; Did I mention that Lucid sucks big time?
  (:import-from lucid destructuring-bind print-unreadable-object row-major-aref)
  #+Lucid
  (:import-from lisp get-setf-method special-form-p)
  #+MCL
  (:import-from ccl class-prototype class-direct-superclasses
		class-direct-subclasses class-precedence-list
                slot-definition-name)
  #+Allegro
  (:import-from clos class-prototype class-direct-superclasses 
		class-direct-subclasses class-precedence-list
		class-finalized-p finalize-inheritance
                class-slots slot-definition-name)
   #+allegro
  (:import-from CLTL1 define-setf-method get-setf-method)
  #+(or Lispworks Lucid)
  (:import-from clos class-prototype class-direct-superclasses 
		class-direct-subclasses class-precedence-list 
		class-finalized-p finalize-inheritance
                validate-superclass
                class-slots slot-definition-name)

  #+genera
  (:import-from "CLOS-INTERNALS"
                "VALIDATE-SUPERCLASS"
                "CLASS-FINALIZED-P" "FINALIZE-INHERITANCE"
		"CLASS-SLOTS"
                "SLOT-DEFINITION-ALLOCATION")

  #+Lispworks
  (:shadow lispworks::without-interrupts)

  #+MCL
  (:shadow ccl::without-interrupts)
  
  #+lucid
  (:export get-setf-method special-form-p))

#+(and CLIM Lispworks)
(export '(GET-SETF-METHOD DEFINE-SETF-METHOD) 'clim-lisp)

(defpackage eksl-user
  (:use COMMON-LISP EKSL-UTILITIES))

;;; ***************************************************************************
;;; EOF
