;;;; -*- Mode: Common-Lisp; Package: COMMON-LISP-USER; Base: 10 -*-
;;;; *-* File: /usr/users/eksl/systems/utils/dev/eksl-utils.system *-*
;;;; *-* Last-edit: Wednesday, July 5, 1995  16:49:50; Edited-By: anderson *-* 
;;;; *-* Machine: Christa (Explorer II, Microcode 489) *-*
;;;; *-* Software: TI Common Lisp System 6.49 *-*
;;;;
;;;; **************************************************************************
;;;; **************************************************************************
;;;; *                                                                        *
;;;; *                   Eksl utilities system definitions                    *
;;;; *                                                                        *
;;;; **************************************************************************
;;;; **************************************************************************
;;;
;;; Written by: David L. Westbrook

;;; Department of Computer Science
;;; University of Massachusetts
;;; Amherst, Massachusetts 01003.

;;; Copyright (c) 1995 University of Massachusetts
;;; Department of Computer Science
;;; Experimental Knowledge Systems Laboratory
;;; Professor Paul Cohen, Director.
;;; All rights reserved.

;;; Permission to use, copy, modify and distribute this software and its
;;; documentation is hereby granted without fee, provided that the above
;;; copyright notice of EKSL, this paragraph and the one following appear
;;; in all copies and in supporting documentation.
;;; EKSL makes no representation about the suitability of this software for any
;;; purposes.  It is provided "AS IS", without express or implied warranties
;;; including (but not limited to) all implied warranties of merchantability
;;; and fitness for a particular purpose, and notwithstanding any other
;;; provision contained herein.  In no event shall EKSL be liable for any
;;; special, indirect or consequential damages whatsoever resulting from loss
;;; of use, data or profits, whether in an action of contract, negligence or
;;; other tortuous action, arising out of or in connection with the use or
;;; performance of this software, even if EKSL is advised of the possiblity of
;;; such damages.
;;;
;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;;
;;;  05-26-95 File Created.  (westy)
;;;
;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;; --*--

(in-package #-MCL :user #+MCL :COMMON-LISP-USER)

;;; --*--
;;; ***************************************************************************

(defparameter *eksl-utils-files*
	      '("package"
		"provide-require"
		"spy"
		"feature-case"
                "macros"
                "timeit"
                "anaphoric"
		"utilities"
                "menus"
		"debugging-utils"
		"make-allocatable"
		"resources"
		"threads"
		"dump"
		"binary-math"
		"points-and-angles"
		"geometry-primitives"
		"testing-functions"
		"io"
		"print-table"
		"priority-queue"
		"day-and-time"
		"distance"
		"clos-utils"
		"hooks"
		"collecting"
		"parameters"
                "clos-mixins"
		#+CLIM
                "clim-utils"
                #+CLIM
                "clim-colors"
		#+CLIM
		"clim-effects"
		"speech"
                "indentation"
                "patches"
		))

(define-eksl-system :eksl-utilities
   :files #.*eksl-utils-files*
   :base-dir (eksl-translate-logical-pathname "EKSL-UTILS:SOURCE;")
   :bin-identifiers (:platform :vendor #+CLIM :gui))


;;; ***************************************************************************
;;; *                              End of File                                *
;;; ***************************************************************************