;;;; -*- Mode: Common-Lisp; Package: COMMON-LISP-USER; Base: 10 -*-
;;;; *-* File: /usr/users/eksl/systems/utils/dev/load-common.lisp *-*
;;;; *-* Last-Edit: Friday, January 19, 1996  13:07:24; Edited-By: Westy *-*
;;;; *-* Machine: Earhart (Alpha) *-*
;;;; *-* Software: Harlequin Common Lisp 3.2 *-*
;;;;
;;;; **************************************************************************
;;;; **************************************************************************
;;;; *                                                                        *
;;;; *                 Common Code for Loading EKSL Utilities                 *
;;;; *                                                                        *
;;;; **************************************************************************
;;;; **************************************************************************
;;;
;;; Written by: David L. Westbrook

;;; Department of Computer Science
;;; University of Massachusetts
;;; Amherst MA 01003-4610

;;; Copyright (c) 1995 University of Massachusetts
;;; Department of Computer Science
;;; Experimental Knowledge Systems Laboratory
;;; Professor Paul Cohen, Director.
;;; All rights reserved.

;;; Permission to use, copy, modify and distribute this software and its
;;; documentation is hereby granted without fee, provided that the above
;;; copyright notice of EKSL, this paragraph and the one following appear
;;; in all copies and in supporting documentation.
;;; EKSL makes no representation about the suitability of this software for any
;;; purposes.  It is provided "AS IS", without express or implied warranties
;;; including (but not limited to) all implied warranties of merchantability
;;; and fitness for a particular purpose, and notwithstanding any other
;;; provision contained herein.  In no event shall EKSL be liable for any
;;; special, indirect or consequential damages whatsoever resulting from loss
;;; of use, data or profits, whether in an action of contract, negligence or
;;; other tortuous action, arising out of or in connection with the use or
;;; performance of this software, even if EKSL is advised of the possiblity of
;;; such damages.
;;;
;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;;
;;;  09-15-95 Added some code to allow partial loading
;;;           of the utilities system.  (Westy)
;;;
;;; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;;; --*--

(in-package :COMMON-LISP-USER)

;;; --*--
;;; ***************************************************************************

(load (merge-pathnames "eksl-utils-translations.lisp" (load-pathname)))
(load (merge-pathnames "eksl-utils-system.lisp"       (load-pathname)))

(defvar *utils-files-to-load* :ALL)

(pushnew "EKSL-UTILS:BINARY;PATCHES" *eksl-all-patch-files* :test #'string-equal)

;;; ---------------------------------------------------------------------------

(defun do-eksl-utils-load (&key compile)
  (case compile
    ((null) (eksl-load-system :eksl-utilities :files *utils-files-to-load*))
    (:recompile (eksl-recompile-system :eksl-utilities :files *utils-files-to-load*))
    (t (eksl-compile-system :eksl-utilities :files *utils-files-to-load*))))

;;; ***************************************************************************
;;; EOF